/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.51 from the
 * contents of Digest-FP56x1xor.xs. Do not edit this file, edit Digest-FP56x1xor.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "Digest-FP56x1xor.xs"
/*
 * Digest::FP56x1xor.xs - C implementation of a 56bit pseudo additive fingerprint hash.
 *
 * (C) 2007-2008 jw@suse.de, Novell Inc.
 * This module is free software. IT may be used
 * and/or modified under the same terms as perl itself.
 *
 * See also 
 *	perldoc perlxs
 * 	perldoc perlguts
 * 	perldoc perlxstut
 * 	perldoc perlapi
 *
 * Currently gen_l() croaks, if no 64bit integers are available
 * and gen() is suggested, which returns a hex string.
 * If the compiler does not respond to 'long long' with 64bit, 
 * we die().
 *
 */
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include "ppport.h"

#define VERSION "0.15"	// keep in sync with Changes, lib/Digest/FP56x1xor.pm

#if !defined(_STDINT_H) && !defined(__WORDSIZE)
// stdint.h and bits/types.h also have these:
typedef unsigned long long uint64_t;
typedef unsigned int       uint32_t;
#endif

static uint64_t rand56[256] = {
#include "random56x256.h"
};

// rotate56 rotates the lower 56 bits in h by m bits.
// The high 8 bit of h are cleared and remain zero.
static uint64_t rotate56(uint64_t h, int m)
{
  uint64_t x = (h << m) & 0x00ffffffffffffffLL;
  h &= 0x00ffffffffffffffLL;
  x |= (h >> (56-m));
  return x;
}

#if 0
// hmm, is this useful? how ould perl work with that
// string? I need to push it into 
// postgresql and sqlite databases and have it compared there.
// the sql statements for this are always 7bit ascii, right?
//
static unsigned char *uint64tostr8(uint64_t h, unsigned char *buf)
{
  unsigned char buf8[9];
  int i;
  if (!buf) buf = buf8;
  for (i = 0; i < 8; i++)
    {
      buf[i] = (unsigned char)((h>>(8*(7-i))) & 0xff);
    }
  return buf; 
}
#endif

// fp is a 64bit integer.
// highest 2 bit are always zero, next 6 bit are the modulo count.
// remaining lower 56 bit are fingerprint hash value.
static uint64_t gen_fp(const char *text, unsigned int len)
{
  uint64_t h = 0;
  unsigned int m = 0;	// byte counter modulo 56
  unsigned int c;

  if (sizeof(uint64_t) != 8)
    croak("sizeof(uint64_t) is %d, need 8\n", (int)sizeof(uint64_t));

  while (len-- > 0)
    {
      c = (unsigned char)*text++;
      uint64_t x = rotate56(rand56[c], m);
      h ^= x;
      if (++m >= 56) m = 0;
    }
  h |= ((uint64_t)m) << 56;
  return h;
}

static uint64_t cat_fp(uint64_t h1, uint64_t h2)
{
  unsigned int m1 = (h1 >> 56);
  unsigned int m2 = (h2 >> 56);
  uint64_t r = rotate56(h2, m1) ^ (h1 & 0x00ffffffffffffffLL);
  m2 += m1;
  if (m2 >= 56) m2 -= 56;
  r |= ((uint64_t)m2)<<56;
  return r; 
}

static int xc2i(unsigned char c)
{
  // ascii has numbers before upper before lower case.
  if (c <= '9') return c - '0';
  if (c <= 'F') return c - 'A' + 10;
  return c - 'a' + 10;
}

static uint64_t x2i64(unsigned char *t, int n)
{
  uint64_t h = 0;
  while (n-- > 0)
    h = (h<<4) + xc2i(*t++);
  return h;
}

static char *ll2x16(uint64_t fp)
{
  static char buf[18];
  sprintf(buf, "%08x%08x", (unsigned int)(fp>>32), (unsigned int)(fp & 0xffffffff));
  return buf;
}

#if 0
// same as ll2x16, but with 0x prefix
// may be used for human consumption. Databases don't like that.
static char *ll2x18(uint64_t fp)
{
  static char buf[20];
  sprintf(buf, "0x%08x%08x", (unsigned int)(fp>>32), (unsigned int)(fp & 0xffffffff));
  return buf;
}
#endif

static uint64_t cat_fp_x(const char *x1, const char *x2)
{
  uint64_t h1 = x2i64((unsigned char *)x1, strlen(x1));
  uint64_t h2 = x2i64((unsigned char *)x2, strlen(x2));
  return cat_fp(h1, h2);
}

// private version of \w, just like perl in ascii C locale.
// but also with quote chars, so that <div id="foo" name=bar>
// is preserverd during cooked()

static int is_word_ch_q(int c)
{
  if ((c <= 'z' && c >= 'a') ||
      (c <= 'Z' && c >= 'A') ||
      (c <= '9' && c >= '0') ||
       c == '_' || c == '"' || c == '\'')
    return 1;
  return 0;
}

// called with len including the trailing \n or \f.
// returns the number of char written to outp
// it never writes more than len chars to out.
static int cook_text(char *outp, const char *text, int len)
{
  char *p = outp;
  char *s = p;
  unsigned char lc = ' ';	// last char we sent to output
  int line_start = 1;		// we are at start of a line.
  int whitespace = 0;		// we saw whitespace chars since lc.

  while (len-- > 0)
    {
      unsigned char c = *text++;
      if (!c) continue;		// completly ignore \0 chars

      if (line_start && (c == '+' || c == '-' || c == '<' || c == '>')) 
        { 
	  line_start = 0; 
	  continue; 		// ignore typ. diff chars at line start.
	}
      line_start = 0;

      if (c <= ' ') 	// (Whitespace: all character codes <= 32)
        {
	  if (c == '\n' || c == '\r' || c == '\f' || c == '\v')
	    line_start = 1;
	  whitespace = 1;
	  continue;
	}

      // output a space *only* to prevent run together words.
      if (whitespace && is_word_ch_q(lc) && is_word_ch_q(c)) *p++ = ' ';
      whitespace = 0;

      // this ~-magic does not really fold utf8 to latin1.
      // maybe it helps to map other encodings.
      if (c >= 128)
        {
	  if (lc < 128) *p++ = '~';
	  lc = c;
	}
      else
        {
	  *p++ = lc = c;
	}
    }

  return p - s;
}


#line 218 "Digest-FP56x1xor.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 362 "Digest-FP56x1xor.c"

XS_EUPXS(XS_Digest__FP56x1xor_gen_l); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Digest__FP56x1xor_gen_l)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "text");
    {
	const char *	text = (const char *)SvPV_nolen(ST(0))
;
	long	RETVAL;
	dXSTARG;
#line 214 "Digest-FP56x1xor.xs"
    if (sizeof(uint64_t) != 8)
      croak("sizeof(uint64_t) is %d, need 8. Please try the gen() method\n", (int)sizeof(uint64_t));
    RETVAL = gen_fp(text, strlen(text));
#line 379 "Digest-FP56x1xor.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Digest__FP56x1xor_cat_l); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Digest__FP56x1xor_cat_l)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "h1, h2");
    {
	long	h1 = (long)SvIV(ST(0))
;
	long	h2 = (long)SvIV(ST(1))
;
	long	RETVAL;
	dXSTARG;
#line 224 "Digest-FP56x1xor.xs"
    RETVAL = cat_fp((uint64_t)h1, (uint64_t)h2);
#line 402 "Digest-FP56x1xor.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Digest__FP56x1xor_gen); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Digest__FP56x1xor_gen)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "sv_text, ...");
    {
	SV *	sv_text = ST(0)
;
	SV *	RETVAL;
#line 231 "Digest-FP56x1xor.xs"
    STRLEN text_len;
    IV start_off;
    IV len;
    const char *text;

    text = (const char *)SvPV(sv_text, text_len);
    if ( items > 1)
      {
        start_off = SvIV(ST(1));
        if (start_off > text_len)
	  croak("specified offset=%d is beyond text_len=%d", 
	    (int)start_off, (int)text_len);
	text_len -= start_off;
      }
    else
      start_off = 0;

    if ( items > 2)
      {
        len = SvIV(ST(2));
	if (len > text_len)
	  croak("specified length=%d exceeds text_len=%d", (int)len, (int)text_len);
        text_len = len;
      }

#line 446 "Digest-FP56x1xor.c"
#line 257 "Digest-FP56x1xor.xs"
    uint64_t fp = gen_fp(text+start_off, text_len);
    RETVAL = newSVpvn(ll2x16(fp), 16);
#line 450 "Digest-FP56x1xor.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Digest__FP56x1xor_cat); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Digest__FP56x1xor_cat)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "x1, x2");
    {
	const char *	x1 = (const char *)SvPV_nolen(ST(0))
;
	const char *	x2 = (const char *)SvPV_nolen(ST(1))
;
	SV *	RETVAL;
#line 266 "Digest-FP56x1xor.xs"
    uint64_t fp = cat_fp_x(x1, x2);
    RETVAL = newSVpvn(ll2x16(fp), 16);
#line 473 "Digest-FP56x1xor.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Digest__FP56x1xor_ll2x); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Digest__FP56x1xor_ll2x)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "fp");
    {
	long	fp = (long)SvIV(ST(0))
;
	SV *	RETVAL;
#line 274 "Digest-FP56x1xor.xs"
    RETVAL = newSVpvn(ll2x16(fp), 16);
#line 493 "Digest-FP56x1xor.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Digest__FP56x1xor_x2l); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Digest__FP56x1xor_x2l)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "x");
    {
	const char *	x = (const char *)SvPV_nolen(ST(0))
;
	long	RETVAL;
	dXSTARG;
#line 281 "Digest-FP56x1xor.xs"
    RETVAL = x2i64((unsigned char *)x, strlen(x));
#line 514 "Digest-FP56x1xor.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Digest__FP56x1xor_cooked); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Digest__FP56x1xor_cooked)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "sv_text, ...");
    {
	SV *	sv_text = ST(0)
;
	SV *	RETVAL;
#line 289 "Digest-FP56x1xor.xs"
    STRLEN text_len;		// like strlen(text), but including '\0' bytes. STRLEN is unsigned!
    IV start_off;
    IV len;
    const char *text;
    char *cooked_text;
    int cooked_len;

    SV *text_out;	

    text = (const char *)SvPV(sv_text, text_len);
    if ( items > 1)
      {
        start_off = SvIV(ST(1));
        if (start_off > text_len)
	  croak("specified offset=%d is beyond text_len=%d", 
	    (int)start_off, (int)text_len);
	text_len -= start_off;
      }
    else
      start_off = 0;

    if ( items > 2)
      {
        len = SvIV(ST(2));
	if (len > text_len)
	  croak("specified length=%d exceeds text_len=%d", (int)len, (int)text_len);
        text_len = len;
      }

#line 562 "Digest-FP56x1xor.c"
#line 319 "Digest-FP56x1xor.xs"
    cooked_text = (char *)malloc(text_len);	// never longer than raw text;
    cooked_len = cook_text(cooked_text, text+start_off, text_len);

    // transfer output from C to perl
    text_out = newSVpvn(cooked_text, cooked_len);

    // forget C
    free((char *)cooked_text);
    // do not free text, it points into perl proper. 
    // (Would cause an abort in PerlIOBuf_close)

    RETVAL = text_out;
#line 576 "Digest-FP56x1xor.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C" {
#endif
XS_EXTERNAL(boot_Digest__FP56x1xor); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Digest__FP56x1xor)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        (void)newXSproto_portable("Digest::FP56x1xor::gen_l", XS_Digest__FP56x1xor_gen_l, file, "$");
        (void)newXSproto_portable("Digest::FP56x1xor::cat_l", XS_Digest__FP56x1xor_cat_l, file, "$$");
        (void)newXSproto_portable("Digest::FP56x1xor::gen", XS_Digest__FP56x1xor_gen, file, "$;@");
        (void)newXSproto_portable("Digest::FP56x1xor::cat", XS_Digest__FP56x1xor_cat, file, "$$");
        (void)newXSproto_portable("Digest::FP56x1xor::ll2x", XS_Digest__FP56x1xor_ll2x, file, "$");
        (void)newXSproto_portable("Digest::FP56x1xor::x2l", XS_Digest__FP56x1xor_x2l, file, "$");
        (void)newXSproto_portable("Digest::FP56x1xor::cooked", XS_Digest__FP56x1xor_cooked, file, "$;@");
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

#ifdef __cplusplus
}
#endif
